 contrib/chkpass/chkpass.c                       |   6 +-
 contrib/cube/cubedata.h                         |  15 +-
 contrib/file_fdw/file_fdw.c                     |   2 +-
 contrib/hstore/hstore_gist.c                    |   2 +-
 contrib/hstore/hstore_io.c                      |  18 +-
 contrib/intarray/_int.h                         |   4 +-
 contrib/intarray/_int_gist.c                    |  16 +-
 contrib/ltree/ltree.h                           |  14 +-
 contrib/pageinspect/heapfuncs.c                 |  17 +-
 contrib/pageinspect/rawpage.c                   |   2 +-
 contrib/pg_trgm/trgm.h                          |   2 +-
 contrib/postgres_fdw/postgres_fdw.c             |   2 +-
 contrib/spi/timetravel.c                        |  25 +-
 doc/src/sgml/bki.sgml                           |   9 +-
 doc/src/sgml/client-auth.sgml                   |  36 +-
 doc/src/sgml/config.sgml                        |  58 +--
 doc/src/sgml/custom-scan.sgml                   | 278 ++++++++++++++
 doc/src/sgml/event-trigger.sgml                 | 134 +------
 doc/src/sgml/fdwhandler.sgml                    |  54 +++
 doc/src/sgml/filelist.sgml                      |   1 +
 doc/src/sgml/func.sgml                          |   8 +-
 doc/src/sgml/libpq.sgml                         |   9 +-
 doc/src/sgml/monitoring.sgml                    |   8 -
 doc/src/sgml/perform.sgml                       |  16 +-
 doc/src/sgml/postgres.sgml                      |   1 +
 doc/src/sgml/ref/create_type.sgml               |  25 +-
 doc/src/sgml/release-8.3.sgml                   |   2 +-
 doc/src/sgml/storage.sgml                       | 145 ++------
 doc/src/sgml/wal.sgml                           |  69 ++--
 doc/src/sgml/xfunc.sgml                         |  25 +-
 doc/src/sgml/xtypes.sgml                        |  52 +--
 src/Makefile.shlib                              |   3 -
 src/backend/access/common/heaptuple.c           |   2 +-
 src/backend/access/gist/gistscan.c              |   4 +-
 src/backend/access/heap/heapam.c                |  56 +--
 src/backend/access/heap/syncscan.c              |   5 +-
 src/backend/access/heap/tuptoaster.c            |  18 +-
 src/backend/access/nbtree/nbtutils.c            |   4 +-
 src/backend/access/transam/multixact.c          |   5 +-
 src/backend/access/transam/twophase.c           |   9 +-
 src/backend/access/transam/xact.c               |  29 +-
 src/backend/access/transam/xlog.c               | 299 ++++-----------
 src/backend/bootstrap/bootparse.y               |  17 +-
 src/backend/bootstrap/bootscanner.l             |   3 -
 src/backend/bootstrap/bootstrap.c               |  56 ++-
 src/backend/catalog/Catalog.pm                  |  24 +-
 src/backend/catalog/genbki.pl                   |  65 +---
 src/backend/catalog/namespace.c                 |  13 +-
 src/backend/catalog/objectaddress.c             |  10 +-
 src/backend/catalog/toasting.c                  |   2 +-
 src/backend/commands/async.c                    |  22 +-
 src/backend/commands/event_trigger.c            |  37 +-
 src/backend/commands/explain.c                  |  19 +-
 src/backend/commands/prepare.c                  |   5 +-
 src/backend/commands/sequence.c                 |  23 --
 src/backend/commands/tablecmds.c                |  26 +-
 src/backend/commands/tablespace.c               |   2 +-
 src/backend/commands/trigger.c                  |  10 +-
 src/backend/commands/typecmds.c                 | 127 +++++++
 src/backend/executor/execQual.c                 | 132 +++----
 src/backend/executor/execScan.c                 |   4 +
 src/backend/executor/functions.c                |   6 +-
 src/backend/executor/nodeAgg.c                  |  14 +-
 src/backend/executor/nodeCustom.c               |  38 +-
 src/backend/executor/nodeForeignscan.c          |  34 +-
 src/backend/executor/nodeHash.c                 |   2 +-
 src/backend/executor/nodeSubplan.c              |   4 +-
 src/backend/executor/spi.c                      |   5 +-
 src/backend/foreign/foreign.c                   |  32 +-
 src/backend/lib/pairingheap.c                   |  59 ---
 src/backend/libpq/auth.c                        |   3 +-
 src/backend/libpq/be-secure-openssl.c           | 104 +++++-
 src/backend/libpq/be-secure.c                   | 143 ++++---
 src/backend/libpq/hba.c                         |  42 ++-
 src/backend/libpq/ip.c                          |  73 ++++
 src/backend/libpq/pqcomm.c                      |   3 +-
 src/backend/main/main.c                         |   6 +
 src/backend/nodes/copyfuncs.c                   |   8 +-
 src/backend/nodes/equalfuncs.c                  |   3 -
 src/backend/nodes/nodeFuncs.c                   |  18 +-
 src/backend/nodes/outfuncs.c                    |  38 +-
 src/backend/nodes/params.c                      |   5 +-
 src/backend/nodes/readfuncs.c                   |   2 -
 src/backend/optimizer/README                    |  34 +-
 src/backend/optimizer/path/costsize.c           |   6 +-
 src/backend/optimizer/path/joinpath.c           |  75 ++--
 src/backend/optimizer/plan/createplan.c         |  78 +++-
 src/backend/optimizer/plan/planagg.c            |   1 -
 src/backend/optimizer/plan/planner.c            |  23 +-
 src/backend/optimizer/plan/setrefs.c            |  63 +++-
 src/backend/optimizer/plan/subselect.c          |   8 +-
 src/backend/optimizer/prep/prepqual.c           |   2 -
 src/backend/optimizer/prep/prepsecurity.c       |  37 +-
 src/backend/optimizer/prep/prepunion.c          |   2 +-
 src/backend/optimizer/util/clauses.c            |   3 -
 src/backend/optimizer/util/plancat.c            |  10 +-
 src/backend/optimizer/util/relnode.c            |  13 +
 src/backend/parser/gram.y                       | 155 +++-----
 src/backend/parser/parse_clause.c               |   9 +-
 src/backend/parser/parse_expr.c                 | 278 ++++++--------
 src/backend/parser/parse_utilcmd.c              |  11 -
 src/backend/parser/parser.c                     | 105 +++---
 src/backend/postmaster/checkpointer.c           |   8 +-
 src/backend/postmaster/pgstat.c                 | 110 +-----
 src/backend/postmaster/syslogger.c              |   4 +-
 src/backend/replication/README                  |   2 +-
 src/backend/replication/basebackup.c            |  21 +-
 src/backend/replication/logical/decode.c        |  30 +-
 src/backend/replication/logical/reorderbuffer.c |  26 +-
 src/backend/rewrite/rewriteHandler.c            |   2 +-
 src/backend/rewrite/rewriteManip.c              |   1 -
 src/backend/storage/buffer/bufmgr.c             |  14 -
 src/backend/storage/buffer/freelist.c           |   2 +-
 src/backend/storage/ipc/pmsignal.c              |   2 +-
 src/backend/storage/ipc/procarray.c             |   7 +-
 src/backend/storage/ipc/sinvaladt.c             |  13 +-
 src/backend/storage/large_object/inv_api.c      |  16 +-
 src/backend/tcop/postgres.c                     |   5 +-
 src/backend/tcop/utility.c                      |  64 +---
 src/backend/utils/Gen_fmgrtab.pl                |   2 +-
 src/backend/utils/adt/array_userfuncs.c         | 244 +++++-------
 src/backend/utils/adt/arrayfuncs.c              | 264 +++++--------
 src/backend/utils/adt/domains.c                 |  78 ++--
 src/backend/utils/adt/geo_ops.c                 |  22 +-
 src/backend/utils/adt/json.c                    |  43 ++-
 src/backend/utils/adt/jsonb.c                   |  81 ++--
 src/backend/utils/adt/jsonfuncs.c               |  18 +-
 src/backend/utils/adt/numeric.c                 |  10 +-
 src/backend/utils/adt/pgstatfuncs.c             |   8 -
 src/backend/utils/adt/rowtypes.c                |  52 +--
 src/backend/utils/adt/ruleutils.c               |  43 +--
 src/backend/utils/adt/timestamp.c               | 128 -------
 src/backend/utils/adt/trigfuncs.c               |   6 +-
 src/backend/utils/adt/tsgistidx.c               |   2 +-
 src/backend/utils/adt/tsrank.c                  |  28 +-
 src/backend/utils/adt/tsvector_op.c             |   2 +-
 src/backend/utils/adt/txid.c                    |   3 +-
 src/backend/utils/adt/xml.c                     |   2 +-
 src/backend/utils/cache/catcache.c              |   2 +-
 src/backend/utils/cache/inval.c                 |  12 +-
 src/backend/utils/cache/typcache.c              | 407 +-------------------
 src/backend/utils/fmgr/dfmgr.c                  |  11 +-
 src/backend/utils/misc/guc.c                    | 473 ++++++++++++------------
 src/backend/utils/misc/postgresql.conf.sample   |   5 +-
 src/backend/utils/mmgr/README                   | 243 ++++++------
 src/backend/utils/mmgr/aset.c                   |  34 +-
 src/backend/utils/mmgr/mcxt.c                   |  99 ++---
 src/backend/utils/sort/logtape.c                |  14 +-
 src/bin/pg_basebackup/t/010_pg_basebackup.pl    |  15 +-
 src/bin/pg_dump/compress_io.c                   |  38 +-
 src/bin/pg_dump/dumputils.c                     |   3 +-
 src/bin/pg_dump/dumputils.h                     |   2 +-
 src/bin/pg_dump/pg_backup_archiver.c            |  17 +-
 src/bin/pg_dump/pg_dump.c                       |  19 +-
 src/common/Makefile                             |   2 -
 src/include/access/brin_page.h                  |   7 +-
 src/include/access/gin_private.h                |  32 +-
 src/include/access/gist_private.h               |   7 +-
 src/include/access/heapam_xlog.h                |   2 +-
 src/include/access/htup_details.h               |  12 +-
 src/include/access/spgist_private.h             |  10 +-
 src/include/access/tuptoaster.h                 |   2 +-
 src/include/access/xact.h                       |   8 +-
 src/include/access/xlog.h                       |   9 +-
 src/include/bootstrap/bootstrap.h               |   6 +-
 src/include/c.h                                 |  10 +-
 src/include/catalog/catversion.h                |   2 +-
 src/include/catalog/genbki.h                    |   2 -
 src/include/catalog/namespace.h                 |   4 +-
 src/include/catalog/pg_authid.h                 |   2 -
 src/include/catalog/pg_description.h            |   2 +-
 src/include/catalog/pg_extension.h              |   4 +-
 src/include/catalog/pg_largeobject.h            |   2 +-
 src/include/catalog/pg_pltemplate.h             |   4 +-
 src/include/catalog/pg_proc.h                   |  20 +-
 src/include/catalog/pg_seclabel.h               |   4 +-
 src/include/catalog/pg_shdescription.h          |   2 +-
 src/include/catalog/pg_shseclabel.h             |   4 +-
 src/include/catalog/pg_trigger.h                |   2 +-
 src/include/commands/dbcommands.h               |  15 +
 src/include/commands/event_trigger.h            |   1 -
 src/include/commands/tablespace.h               |   2 +-
 src/include/commands/typecmds.h                 |   2 +
 src/include/executor/hashjoin.h                 |   2 +-
 src/include/foreign/fdwapi.h                    |  15 +
 src/include/lib/pairingheap.h                   |  11 -
 src/include/libpq/ip.h                          |   5 +
 src/include/libpq/libpq-be.h                    |   4 +-
 src/include/nodes/bitmapset.h                   |   4 +-
 src/include/nodes/execnodes.h                   |   5 +-
 src/include/nodes/memnodes.h                    |   8 +-
 src/include/nodes/params.h                      |   2 +-
 src/include/nodes/parsenodes.h                  |  10 +-
 src/include/nodes/plannodes.h                   |  23 +-
 src/include/nodes/primnodes.h                   |   3 +-
 src/include/nodes/relation.h                    |   2 +
 src/include/nodes/tidbitmap.h                   |   4 +-
 src/include/optimizer/paths.h                   |  13 +
 src/include/optimizer/planmain.h                |   2 +-
 src/include/parser/gramparse.h                  |   2 -
 src/include/pgstat.h                            |   8 +-
 src/include/pgtar.h                             |  10 +-
 src/include/port.h                              |   2 +
 src/include/postgres.h                          |   8 +-
 src/include/postmaster/syslogger.h              |   2 +-
 src/include/replication/reorderbuffer.h         |  10 +-
 src/include/replication/slot.h                  |   4 -
 src/include/replication/walsender_private.h     |   4 +-
 src/include/storage/bufpage.h                   |   2 +-
 src/include/storage/fsm_internals.h             |   2 +-
 src/include/storage/s_lock.h                    |   2 +-
 src/include/storage/standby.h                   |   4 +-
 src/include/tsearch/dicts/regis.h               |   2 +-
 src/include/tsearch/dicts/spell.h               |   6 +-
 src/include/tsearch/ts_type.h                   |  13 +-
 src/include/utils/array.h                       |  32 +-
 src/include/utils/catcache.h                    |   4 +-
 src/include/utils/datetime.h                    |   4 +-
 src/include/utils/geo_decls.h                   |   4 +-
 src/include/utils/guc.h                         |  24 +-
 src/include/utils/jsonb.h                       |   2 +-
 src/include/utils/memutils.h                    |   5 +-
 src/include/utils/palloc.h                      |  20 -
 src/include/utils/relmapper.h                   |   2 +-
 src/include/utils/timestamp.h                   |   2 -
 src/include/utils/typcache.h                    |  37 --
 src/include/utils/varbit.h                      |   3 +-
 src/interfaces/ecpg/ecpglib/data.c              |   8 +-
 src/interfaces/ecpg/ecpglib/extern.h            |   2 +-
 src/interfaces/ecpg/preproc/parse.pl            |   6 +-
 src/interfaces/ecpg/preproc/parser.c            | 116 +++---
 src/interfaces/libpq/fe-connect.c               |  60 +--
 src/interfaces/libpq/fe-exec.c                  |   3 +-
 src/interfaces/libpq/fe-misc.c                  |  27 +-
 src/interfaces/libpq/fe-secure-openssl.c        |   9 +-
 src/interfaces/libpq/libpq-int.h                |   4 +-
 src/pl/plperl/plperl.c                          |   2 +-
 src/pl/plpgsql/src/pl_exec.c                    | 333 ++++++++---------
 src/pl/plpgsql/src/pl_funcs.c                   |   2 +-
 src/pl/plpgsql/src/pl_gram.y                    |  42 +--
 src/pl/plpgsql/src/plpgsql.h                    |   3 +-
 src/port/Makefile                               |   2 -
 src/port/dirmod.c                               |  12 +-
 src/port/gettimeofday.c                         |  23 +-
 src/port/pgcheckdir.c                           |  23 +-
 src/port/tar.c                                  |  10 +-
 src/test/regress/expected/copy2.out             |  34 --
 src/test/regress/expected/domain.out            |  30 --
 src/test/regress/expected/event_trigger.out     |  19 -
 src/test/regress/expected/foreign_data.out      |   2 +-
 src/test/regress/expected/join.out              |  19 -
 src/test/regress/expected/json.out              |  24 --
 src/test/regress/expected/json_1.out            |  24 --
 src/test/regress/expected/jsonb.out             |  24 --
 src/test/regress/expected/jsonb_1.out           |  24 --
 src/test/regress/expected/object_address.out    |   6 +-
 src/test/regress/expected/opr_sanity.out        |   6 +-
 src/test/regress/expected/plpgsql.out           |  12 -
 src/test/regress/expected/rowsecurity.out       |  64 ++--
 src/test/regress/expected/rules.out             |  54 ---
 src/test/regress/expected/stats.out             |  74 +---
 src/test/regress/expected/updatable_views.out   | 264 ++++++-------
 src/test/regress/expected/with.out              |  15 -
 src/test/regress/pg_regress.c                   |   2 +-
 src/test/regress/sql/copy2.sql                  |  19 -
 src/test/regress/sql/domain.sql                 |  27 --
 src/test/regress/sql/event_trigger.sql          |  19 -
 src/test/regress/sql/join.sql                   |   9 -
 src/test/regress/sql/json.sql                   |   6 -
 src/test/regress/sql/jsonb.sql                  |   6 -
 src/test/regress/sql/plpgsql.sql                |  10 +-
 src/test/regress/sql/rules.sql                  |  18 -
 src/test/regress/sql/stats.sql                  |  70 +---
 src/test/regress/sql/with.sql                   |   5 -
 src/test/ssl/Makefile                           |   2 +-
 src/test/ssl/ssl/both-cas-1.crt                 |  50 +--
 src/test/ssl/ssl/both-cas-2.crt                 |  50 +--
 src/test/ssl/ssl/client-revoked.crt             |  16 +-
 src/test/ssl/ssl/client-revoked.key             |  26 +-
 src/test/ssl/ssl/client.crl                     |  12 +-
 src/test/ssl/ssl/client.crt                     |  16 +-
 src/test/ssl/ssl/client.key                     |  26 +-
 src/test/ssl/ssl/client_ca.crt                  |  16 +-
 src/test/ssl/ssl/client_ca.key                  |  26 +-
 src/test/ssl/ssl/root+client.crl                |  22 +-
 src/test/ssl/ssl/root+client_ca.crt             |  34 +-
 src/test/ssl/ssl/root+server.crl                |  22 +-
 src/test/ssl/ssl/root+server_ca.crt             |  34 +-
 src/test/ssl/ssl/root.crl                       |  10 +-
 src/test/ssl/ssl/root_ca.crt                    |  18 +-
 src/test/ssl/ssl/root_ca.key                    |  26 +-
 src/test/ssl/ssl/server-cn-and-alt-names.crt    |  18 +-
 src/test/ssl/ssl/server-cn-and-alt-names.key    |  26 +-
 src/test/ssl/ssl/server-cn-only.crt             |  16 +-
 src/test/ssl/ssl/server-cn-only.key             |  26 +-
 src/test/ssl/ssl/server-multiple-alt-names.crt  |  16 +-
 src/test/ssl/ssl/server-multiple-alt-names.key  |  26 +-
 src/test/ssl/ssl/server-no-names.crt            |  14 +-
 src/test/ssl/ssl/server-no-names.key            |  26 +-
 src/test/ssl/ssl/server-revoked.crt             |  16 +-
 src/test/ssl/ssl/server-revoked.key             |  26 +-
 src/test/ssl/ssl/server-single-alt-name.crt     |  14 +-
 src/test/ssl/ssl/server-single-alt-name.key     |  26 +-
 src/test/ssl/ssl/server-ss.crt                  |  16 +-
 src/test/ssl/ssl/server-ss.key                  |  26 +-
 src/test/ssl/ssl/server.crl                     |  12 +-
 src/test/ssl/ssl/server_ca.crt                  |  16 +-
 src/test/ssl/ssl/server_ca.key                  |  26 +-
 src/tools/msvc/Solution.pm                      |  14 +-
 src/tools/msvc/VSObjectFactory.pm               |  28 +-
 310 files changed, 3810 insertions(+), 5469 deletions(-)

diff --git a/contrib/chkpass/chkpass.c b/contrib/chkpass/chkpass.c
index 9425c08..283ad9a 100644
--- a/contrib/chkpass/chkpass.c
+++ b/contrib/chkpass/chkpass.c
@@ -65,7 +65,7 @@ chkpass_in(PG_FUNCTION_ARGS)
 	/* special case to let us enter encrypted passwords */
 	if (*str == ':')
 	{
-		result = (chkpass *) palloc0(sizeof(chkpass));
+		result = (chkpass *) palloc(sizeof(chkpass));
 		strlcpy(result->password, str + 1, 13 + 1);
 		PG_RETURN_POINTER(result);
 	}
@@ -75,7 +75,7 @@ chkpass_in(PG_FUNCTION_ARGS)
 				(errcode(ERRCODE_DATA_EXCEPTION),
 				 errmsg("password \"%s\" is weak", str)));
 
-	result = (chkpass *) palloc0(sizeof(chkpass));
+	result = (chkpass *) palloc(sizeof(chkpass));
 
 	mysalt[0] = salt_chars[random() & 0x3f];
 	mysalt[1] = salt_chars[random() & 0x3f];
@@ -107,7 +107,7 @@ chkpass_out(PG_FUNCTION_ARGS)
 
 	result = (char *) palloc(16);
 	result[0] = ':';
-	strlcpy(result + 1, password->password, 15);
+	strcpy(result + 1, password->password);
 
 	PG_RETURN_CSTRING(result);
 }
diff --git a/contrib/cube/cubedata.h b/contrib/cube/cubedata.h
index 719e43d..5d44e11 100644
--- a/contrib/cube/cubedata.h
+++ b/contrib/cube/cubedata.h
@@ -23,10 +23,11 @@ typedef struct NDBOX
 	unsigned int header;
 
 	/*
-	 * The lower left coordinates for each dimension come first, followed by
-	 * upper right coordinates unless the point flag is set.
+	 * Variable length array. The lower left coordinates for each dimension
+	 * come first, followed by upper right coordinates unless the point flag
+	 * is set.
 	 */
-	double		x[FLEXIBLE_ARRAY_MEMBER];
+	double		x[1];
 } NDBOX;
 
 #define POINT_BIT			0x80000000
@@ -40,9 +41,9 @@ typedef struct NDBOX
 #define LL_COORD(cube, i) ( (cube)->x[i] )
 #define UR_COORD(cube, i) ( IS_POINT(cube) ? (cube)->x[i] : (cube)->x[(i) + DIM(cube)] )
 
-#define POINT_SIZE(_dim)	(offsetof(NDBOX, x) + sizeof(double)*(_dim))
-#define CUBE_SIZE(_dim)		(offsetof(NDBOX, x) + sizeof(double)*(_dim)*2)
+#define POINT_SIZE(_dim) (offsetof(NDBOX, x[0]) + sizeof(double)*(_dim))
+#define CUBE_SIZE(_dim) (offsetof(NDBOX, x[0]) + sizeof(double)*(_dim)*2)
 
-#define DatumGetNDBOX(x)	((NDBOX *) PG_DETOAST_DATUM(x))
-#define PG_GETARG_NDBOX(x)	DatumGetNDBOX(PG_GETARG_DATUM(x))
+#define DatumGetNDBOX(x)	((NDBOX*)DatumGetPointer(x))
+#define PG_GETARG_NDBOX(x)	DatumGetNDBOX( PG_DETOAST_DATUM(PG_GETARG_DATUM(x)) )
 #define PG_RETURN_NDBOX(x)	PG_RETURN_POINTER(x)
diff --git a/contrib/file_fdw/file_fdw.c b/contrib/file_fdw/file_fdw.c
index 4368897..d569760 100644
--- a/contrib/file_fdw/file_fdw.c
+++ b/contrib/file_fdw/file_fdw.c
@@ -932,7 +932,7 @@ estimate_size(PlannerInfo *root, RelOptInfo *baserel,
 		int			tuple_width;
 
 		tuple_width = MAXALIGN(baserel->width) +
-			MAXALIGN(SizeofHeapTupleHeader);
+			MAXALIGN(sizeof(HeapTupleHeaderData));
 		ntuples = clamp_row_est((double) stat_buf.st_size /
 								(double) tuple_width);
 	}
diff --git a/contrib/hstore/hstore_gist.c b/contrib/hstore/hstore_gist.c
index f375f5d..54e96fc 100644
--- a/contrib/hstore/hstore_gist.c
+++ b/contrib/hstore/hstore_gist.c
@@ -41,7 +41,7 @@ typedef struct
 {
 	int32		vl_len_;		/* varlena header (do not touch directly!) */
 	int32		flag;
-	char		data[FLEXIBLE_ARRAY_MEMBER];
+	char		data[1];
 } GISTTYPE;
 
 #define ALLISTRUE		0x04
diff --git a/contrib/hstore/hstore_io.c b/contrib/hstore/hstore_io.c
index 7d89867..079f662 100644
--- a/contrib/hstore/hstore_io.c
+++ b/contrib/hstore/hstore_io.c
@@ -747,7 +747,7 @@ typedef struct RecordIOData
 	Oid			record_type;
 	int32		record_typmod;
 	int			ncolumns;
-	ColumnIOData columns[FLEXIBLE_ARRAY_MEMBER];
+	ColumnIOData columns[1];	/* VARIABLE LENGTH ARRAY */
 } RecordIOData;
 
 PG_FUNCTION_INFO_V1(hstore_from_record);
@@ -805,8 +805,8 @@ hstore_from_record(PG_FUNCTION_ARGS)
 	{
 		fcinfo->flinfo->fn_extra =
 			MemoryContextAlloc(fcinfo->flinfo->fn_mcxt,
-							   offsetof(RecordIOData, columns) +
-							   ncolumns * sizeof(ColumnIOData));
+							   sizeof(RecordIOData) - sizeof(ColumnIOData)
+							   + ncolumns * sizeof(ColumnIOData));
 		my_extra = (RecordIOData *) fcinfo->flinfo->fn_extra;
 		my_extra->record_type = InvalidOid;
 		my_extra->record_typmod = 0;
@@ -816,8 +816,8 @@ hstore_from_record(PG_FUNCTION_ARGS)
 		my_extra->record_typmod != tupTypmod)
 	{
 		MemSet(my_extra, 0,
-			   offsetof(RecordIOData, columns) +
-			   ncolumns * sizeof(ColumnIOData));
+			   sizeof(RecordIOData) - sizeof(ColumnIOData)
+			   + ncolumns * sizeof(ColumnIOData));
 		my_extra->record_type = tupType;
 		my_extra->record_typmod = tupTypmod;
 		my_extra->ncolumns = ncolumns;
@@ -990,8 +990,8 @@ hstore_populate_record(PG_FUNCTION_ARGS)
 	{
 		fcinfo->flinfo->fn_extra =
 			MemoryContextAlloc(fcinfo->flinfo->fn_mcxt,
-							   offsetof(RecordIOData, columns) +
-							   ncolumns * sizeof(ColumnIOData));
+							   sizeof(RecordIOData) - sizeof(ColumnIOData)
+							   + ncolumns * sizeof(ColumnIOData));
 		my_extra = (RecordIOData *) fcinfo->flinfo->fn_extra;
 		my_extra->record_type = InvalidOid;
 		my_extra->record_typmod = 0;
@@ -1001,8 +1001,8 @@ hstore_populate_record(PG_FUNCTION_ARGS)
 		my_extra->record_typmod != tupTypmod)
 	{
 		MemSet(my_extra, 0,
-			   offsetof(RecordIOData, columns) +
-			   ncolumns * sizeof(ColumnIOData));
+			   sizeof(RecordIOData) - sizeof(ColumnIOData)
+			   + ncolumns * sizeof(ColumnIOData));
 		my_extra->record_type = tupType;
 		my_extra->record_typmod = tupTypmod;
 		my_extra->ncolumns = ncolumns;
diff --git a/contrib/intarray/_int.h b/contrib/intarray/_int.h
index d524f0f..7f93206 100644
--- a/contrib/intarray/_int.h
+++ b/contrib/intarray/_int.h
@@ -73,7 +73,7 @@ typedef struct
 {
 	int32		vl_len_;		/* varlena header (do not touch directly!) */
 	int32		flag;
-	char		data[FLEXIBLE_ARRAY_MEMBER];
+	char		data[1];
 } GISTTYPE;
 
 #define ALLISTRUE		0x04
@@ -133,7 +133,7 @@ typedef struct QUERYTYPE
 {
 	int32		vl_len_;		/* varlena header (do not touch directly!) */
 	int32		size;			/* number of ITEMs */
-	ITEM		items[FLEXIBLE_ARRAY_MEMBER];
+	ITEM		items[1];		/* variable length array */
 } QUERYTYPE;
 
 #define HDRSIZEQT	offsetof(QUERYTYPE, items)
diff --git a/contrib/intarray/_int_gist.c b/contrib/intarray/_int_gist.c
index 876a7b9..53abcc4 100644
--- a/contrib/intarray/_int_gist.c
+++ b/contrib/intarray/_int_gist.c
@@ -416,7 +416,9 @@ g_int_picksplit(PG_FUNCTION_ARGS)
 			size_waste = size_union - size_inter;
 
 			pfree(union_d);
-			pfree(inter_d);
+
+			if (inter_d != (ArrayType *) NULL)
+				pfree(inter_d);
 
 			/*
 			 * are these a more promising split that what we've already seen?
@@ -515,8 +517,10 @@ g_int_picksplit(PG_FUNCTION_ARGS)
 		/* pick which page to add it to */
 		if (size_alpha - size_l < size_beta - size_r + WISH_F(v->spl_nleft, v->spl_nright, 0.01))
 		{
-			pfree(datum_l);
-			pfree(union_dr);
+			if (datum_l)
+				pfree(datum_l);
+			if (union_dr)
+				pfree(union_dr);
 			datum_l = union_dl;
 			size_l = size_alpha;
 			*left++ = i;
@@ -524,8 +528,10 @@ g_int_picksplit(PG_FUNCTION_ARGS)
 		}
 		else
 		{
-			pfree(datum_r);
-			pfree(union_dl);
+			if (datum_r)
+				pfree(datum_r);
+			if (union_dl)
+				pfree(union_dl);
 			datum_r = union_dr;
 			size_r = size_beta;
 			*right++ = i;
diff --git a/contrib/ltree/ltree.h b/contrib/ltree/ltree.h
index c604357..1b1305b 100644
--- a/contrib/ltree/ltree.h
+++ b/contrib/ltree/ltree.h
@@ -10,7 +10,7 @@
 typedef struct
 {
 	uint16		len;
-	char		name[FLEXIBLE_ARRAY_MEMBER];
+	char		name[1];
 } ltree_level;
 
 #define LEVEL_HDRSIZE	(offsetof(ltree_level,name))
@@ -20,7 +20,7 @@ typedef struct
 {
 	int32		vl_len_;		/* varlena header (do not touch directly!) */
 	uint16		numlevel;
-	char		data[FLEXIBLE_ARRAY_MEMBER];
+	char		data[1];
 } ltree;
 
 #define LTREE_HDRSIZE	MAXALIGN( offsetof(ltree, data) )
@@ -34,7 +34,7 @@ typedef struct
 	int32		val;
 	uint16		len;
 	uint8		flag;
-	char		name[FLEXIBLE_ARRAY_MEMBER];
+	char		name[1];
 } lquery_variant;
 
 #define LVAR_HDRSIZE   MAXALIGN(offsetof(lquery_variant, name))
@@ -51,7 +51,7 @@ typedef struct
 	uint16		numvar;
 	uint16		low;
 	uint16		high;
-	char		variants[FLEXIBLE_ARRAY_MEMBER];
+	char		variants[1];
 } lquery_level;
 
 #define LQL_HDRSIZE MAXALIGN( offsetof(lquery_level,variants) )
@@ -72,7 +72,7 @@ typedef struct
 	uint16		numlevel;
 	uint16		firstgood;
 	uint16		flag;
-	char		data[FLEXIBLE_ARRAY_MEMBER];
+	char		data[1];
 } lquery;
 
 #define LQUERY_HDRSIZE	 MAXALIGN( offsetof(lquery, data) )
@@ -107,7 +107,7 @@ typedef struct
 {
 	int32		vl_len_;		/* varlena header (do not touch directly!) */
 	int32		size;
-	char		data[FLEXIBLE_ARRAY_MEMBER];
+	char		data[1];
 } ltxtquery;
 
 #define HDRSIZEQT		MAXALIGN(VARHDRSZ + sizeof(int32))
@@ -208,7 +208,7 @@ typedef struct
 {
 	int32		vl_len_;		/* varlena header (do not touch directly!) */
 	uint32		flag;
-	char		data[FLEXIBLE_ARRAY_MEMBER];
+	char		data[1];
 } ltree_gist;
 
 #define LTG_ONENODE 0x01
diff --git a/contrib/pageinspect/heapfuncs.c b/contrib/pageinspect/heapfuncs.c
index 8d1666c..c8876f3 100644
--- a/contrib/pageinspect/heapfuncs.c
+++ b/contrib/pageinspect/heapfuncs.c
@@ -149,7 +149,7 @@ heap_page_items(PG_FUNCTION_ARGS)
 		 * many other ways, but at least we won't crash.
 		 */
 		if (ItemIdHasStorage(id) &&
-			lp_len >= MinHeapTupleSize &&
+			lp_len >= sizeof(HeapTupleHeader) &&
 			lp_offset == MAXALIGN(lp_offset) &&
 			lp_offset + lp_len <= raw_page_size)
 		{
@@ -169,19 +169,18 @@ heap_page_items(PG_FUNCTION_ARGS)
 			values[10] = UInt8GetDatum(tuphdr->t_hoff);
 
 			/*
-			 * We already checked that the item is completely within the raw
-			 * page passed to us, with the length given in the line pointer.
-			 * Let's check that t_hoff doesn't point over lp_len, before using
-			 * it to access t_bits and oid.
+			 * We already checked that the item as is completely within the
+			 * raw page passed to us, with the length given in the line
+			 * pointer.. Let's check that t_hoff doesn't point over lp_len,
+			 * before using it to access t_bits and oid.
 			 */
-			if (tuphdr->t_hoff >= SizeofHeapTupleHeader &&
-				tuphdr->t_hoff <= lp_len &&
-				tuphdr->t_hoff == MAXALIGN(tuphdr->t_hoff))
+			if (tuphdr->t_hoff >= sizeof(HeapTupleHeader) &&
+				tuphdr->t_hoff <= lp_len)
 			{
 				if (tuphdr->t_infomask & HEAP_HASNULL)
 				{
 					bits_len = tuphdr->t_hoff -
-						offsetof(HeapTupleHeaderData, t_bits);
+						(((char *) tuphdr->t_bits) -((char *) tuphdr));
 
 					values[11] = CStringGetTextDatum(
 								 bits_to_text(tuphdr->t_bits, bits_len * 8));
diff --git a/contrib/pageinspect/rawpage.c b/contrib/pageinspect/rawpage.c
index 38c136f..1dada09 100644
--- a/contrib/pageinspect/rawpage.c
+++ b/contrib/pageinspect/rawpage.c
@@ -192,7 +192,7 @@ page_header(PG_FUNCTION_ARGS)
 	 * Check that enough data was supplied, so that we don't try to access
 	 * fields outside the supplied buffer.
 	 */
-	if (raw_page_size < SizeOfPageHeaderData)
+	if (raw_page_size < sizeof(PageHeaderData))
 		ereport(ERROR,
 				(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
 				 errmsg("input page too small (%d bytes)", raw_page_size)));
diff --git a/contrib/pg_trgm/trgm.h b/contrib/pg_trgm/trgm.h
index f030558..ed649b8 100644
--- a/contrib/pg_trgm/trgm.h
+++ b/contrib/pg_trgm/trgm.h
@@ -63,7 +63,7 @@ typedef struct
 {
 	int32		vl_len_;		/* varlena header (do not touch directly!) */
 	uint8		flag;
-	char		data[FLEXIBLE_ARRAY_MEMBER];
+	char		data[1];
 } TRGM;
 
 #define TRGMHDRSIZE		  (VARHDRSZ + sizeof(uint8))
diff --git a/contrib/postgres_fdw/postgres_fdw.c b/contrib/postgres_fdw/postgres_fdw.c
index 63f0577..d76e739 100644
--- a/contrib/postgres_fdw/postgres_fdw.c
+++ b/contrib/postgres_fdw/postgres_fdw.c
@@ -519,7 +519,7 @@ postgresGetForeignRelSize(PlannerInfo *root,
 		{
 			baserel->pages = 10;
 			baserel->tuples =
-				(10 * BLCKSZ) / (baserel->width + MAXALIGN(SizeofHeapTupleHeader));
+				(10 * BLCKSZ) / (baserel->width + sizeof(HeapTupleHeaderData));
 		}
 
 		/* Estimate baserel size as best we can with local statistics. */
